
## mTCP for Bluefield smartNIC

### mTCP code changes
The material in "documentation" folder provides details on code changes required to run mTCP over Bluefield ARM cores.

### Configure and compile mTCP
1. Download and configure DPDK-19.11.8 using Alternative-2, as discussed in DPDK README
2. Setup the MTCP-DPDK environment; this involves integration of DPDK with mTCP
    a. $ export RTE_SDK=<absolute-path-to-dpdk-stable-19.11.8>
    b. $ export RTE_TARGET=arm64-bluefield-linuxapp-gcc //For Bluefield smartNIC OR
    
        $ export RTE_TARGET=x86_64-native-linuxapp-gcc //For Host
    c. Configure mTCP with our DPDK version

        .../mtcp-devel$ ./configure --with-dpdk-lib=$RTE_SDK/$RTE_TARGET CFLAGS="-DMAX_CPUS=<num_host/nic_cpus>" 
        // Use --disable-hwcsum when working in virtualized environment
        // If there an error: “configure: error: Could not find gmp.h”;  $ sudo apt install libgmp-dev
    d. Integrate mTCP with our DPDK version

        <path-to-mtcp-devel>$ sudo ./setup_mtcp_dpdk_env.sh <absolute-path-to-dpdk-stable-19.11.8>
3. Compile mTCP
    
    .../mtcp-devel$ make -j
4. To revert back mTCP NIC changes
    <path-to-mtcp-devel>$ ./setup_linux_env.sh <path to $RTE_SDK>

### Run mTCP sample application "HTTP server"
1. Configure static ARP entries

    .../mtcp-devel/apps/example/config$ vim arp.conf 

    //Add ARP entries for remote IPs (see example below)
    
        ```ARP_ENTRY 6
        192.168.200.10/32 0c:42:a1:df:ac:48
        192.168.210.10/32 0c:42:a1:df:ac:49
        192.168.200.20/32 0c:42:a1:df:ac:42
        192.168.210.20/32 0c:42:a1:df:ac:43
        192.168.200.30/32 0c:42:a1:df:ac:41
        192.168.210.30/32 0c:42:a1:df:ac:40```
        
